<?php

namespace App\Services\Part;

use RuntimeException;
use App\Models\Part\DISKModel;
use App\Helpers\Part\DISKHelper;
use App\Forms\Part\DISKForm;
use App\Entities\Part\DISKEntity;
use App\Entities\Equipment\ServerPartEntity;

class DISKService extends PartType1Service
{
    protected string $formClass = DISKForm::class;
    protected string $helperClass = DISKHelper::class;

    public function __construct(DISKModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('DISK');
    }
    public function getEntityClass(): string
    {
        return DISKEntity::class;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): DISKEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy('title ASC');
        parent::setOrderBy($field, $value);
    }

    //서버파트관련 작업
    //파트정보가져오기
    public function getPartEntityByServerPart(ServerPartEntity $serverPartEntity): DISKEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverPartEntity->getPartUid());
        if (!$entity instanceof DISKEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 디스크정보를 찾을수없습니다.");
        }
        return $entity;
    }
    public function detachFromServerPart(ServerPartEntity $serverPartEntity, array $formDatas = []): DiskEntity
    {
        /** @var DiskEntity $entity IDE에 entity type알려주기*/
        $entity = $this->getPartEntityByServerPart($serverPartEntity);
        $formDatas['format'] = $entity->getFormat() + $serverPartEntity->getCnt();
        $entity = parent::detachFromServerPart($serverPartEntity, $formDatas);
        if (!$entity instanceof DiskEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 디스크정보를 찾을수없습니다.");
        }
        return $entity;
    }
}
